
#include <iostream>
#include <cstdlib>
#include <cstddef>


typedef int* IntArrayPtr;

void fill_array(int a[], int size);

void bubble_sort(int arrNumbers[], int length);

int main( )
{
   using namespace std;

    cout << " This program sorts numbers from lowest to highest " << endl;

    int array_size;

    cout << " How many numbers will be sorted? ";

    cin >> array_size;

    IntArrayPtr a;

    a = new int[array_size];

    fill_array(a, array_size );

    bubble_sort(a , array_size );
 
    cout << " In sorted order the numbers are " << endl;

    for(int index = 0; index < array_size; index++ )
        cout << a[index] << " " ;

   cout << endl;

   delete []a;

   return 0;

}

void fill_array(int a[], int size)
{
  
   using namespace std;

   cout << "Enter " << size << " integers " << endl;

   for( int index = 0; index < size;  index++ )
       cin >> a[index];

}

void bubble_sort(int arrNumbers[], int length)
{
  int i, j, temp;
  int test; 
  for(i = length - 1; i > 0; i--)
  {
    test=0;
    for(j = 0; j < i; j++)
    {
      if(arrNumbers[j] > arrNumbers[j+1]) /* compare neighboring elements */
      {
        temp = arrNumbers[j];    /* swap array[j] and array[j+1] */
        arrNumbers[j] = arrNumbers[j+1];
        arrNumbers[j+1] = temp;
        test=1;
      }
    } /*end for j*/
    if(test==0) 
       break; /*will exit if the list is sorted!*/
  } 
      
}

